/* MAIN */
const attemptifyAsync = (fn, onError) => {
    return function attemptified() {
        return fn.apply(undefined, arguments).catch(onError);
    };
};
const attemptifySync = (fn, onError) => {
    return function attemptified() {
        try {
            return fn.apply(undefined, arguments);
        }
        catch (error) {
            return onError(error);
        }
    };
};
/* EXPORT */
export { attemptifyAsync, attemptifySync };
